WebSocketClient::WebSocketConnectionObject Class Reference

class for websocket connections; returns an object of class WebSocketClient for receiving websocket events from a websocket server More...

Inheritance diagram for WebSocketClient::WebSocketConnectionObject:
[legend]

## Public Member Functions

| constructor (string name, string desc, string url, bool monitor, *hash opts, hash urlh)
| creates the WebSocketConnectionObject object More...
*hash | getDefaultOptions ()
| returns default options
hash | getOptions ()
| gets options
*hash | getRuntimeOptions ()
| returns runtime options More...
string | getType ()
| returns `"websocket"`

## Static Public Member Functions

static WebSocketConnectionObject | make (string name, string desc, string url, bool monitor, *hash opts, hash urlh)
| static constructor

## Private Member Functions

WebSocketClient | getImpl (bool connect=True, *hash rtopts)
| returns a WebSocketClient object More...

## Detailed Description

class for websocket connections; returns an object of class WebSocketClient for receiving websocket events from a websocket server

supports the following options:

- `"connect_timeout"`: connection timeout to use in milliseconds
- `"http_version"`: HTTP version to use (`"1.0"` or `"1.1"`, defaults to `"1.1"`)
- `"max_redirects"`: maximum redirects to support
- `"proxy"`: proxy URL to use
- `"timeout"`: transfer timeout to use in milliseconds

also supports the following runtime options in getImpl():

- `"callback"`: (required) a callback to receive websocket events
- `"dbglog"`: a closure taking a single string for detailed technical connection logging
- `"errlog"`: a closure accepting a single string for error logging
- `"log"`: a closure accepting a single string for logging
- `"yield"`: a closure to yield current thread execution

## Member Function Documentation

## constructor()

WebSocketClient::WebSocketConnectionObject::constructor | ( | string | name,
|  | string | desc,
|  | string | url,
|  | bool | monitor,
|  | *hash | opts,
|  | hash | urlh
| ) |  |

creates the WebSocketConnectionObject object

Parameters

  name | the name of the connection
  desc | connection description
  url | connection URL
  monitor | monitoring flag
  opts | connection options
  urlh | broken down URL hash (as returned by Qore::parse_url())

## getImpl()

WebSocketClient WebSocketClient::WebSocketConnectionObject::getImpl | ( | bool | connect = `True`,
|  | *hash | rtopts
| ) |  |

private virtual

returns a WebSocketClient object

Parameters

  connect | if True, then WebSocketClient::connect() is called

  rtopts

  supports the following runtime options in getImpl():
  - `"callback"`: (required) a callback to receive websocket events
  - `"dbglog"`: a closure taking a single string for detailed technical connection logging
  - `"errlog"`: a closure accepting a single string for error logging
  - `"log"`: a closure accepting a single string for logging
  - `"yield"`: a closure to yield current thread execution

Returns
  a WebSocketClient object

Implements ConnectionProvider::AbstractConnection.

## getRuntimeOptions()

*hash WebSocketClient::WebSocketConnectionObject::getRuntimeOptions | ( |  | ) |

returns runtime options

Returns
  a hash with the following keys reflecting support for the corresponding runtime options in getImpl():
  - `"callback"`: (required) a callback to receive websocket events
  - `"dbglog"`: a closure taking a single string for detailed technical connection logging
  - `"errlog"`: a closure accepting a single string for error logging
  - `"log"`: a closure accepting a single string for logging
  - `"yield"`: a closure to yield current thread execution